﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel.DataAnnotations;
using System.ComponentModel.DataAnnotations.Schema;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using PropertyChanged;

namespace DataEntity
{
    [AddINotifyPropertyChangedInterface]

    [Table("Materialy")]
    public partial class Material : BaseModel
    {

        [Key]
        [Column (Order=1)]
        public int MaterialId { get; set; }

        [Required(ErrorMessage = "Název materiálu je povinné pole")]
        [StringLength(255, ErrorMessage = "Délka musí být do 255 znaků")]
        public string NazevMat { get; set; } 

        [Required (ErrorMessage = "Pojistné množství je povinné pole")]
        [Range (0, int.MaxValue, ErrorMessage = "Musí být kladné číslo")]
        public int MnozPoj { get; set; }

        [Required(ErrorMessage = "Množství do palety je povinné pole")]
        [Range(0, int.MaxValue, ErrorMessage = "Musí být kladné číslo")]
        public int MnozDoPal { get; set; }

        public string Komentar { get; set; }

        [Column (TypeName = "date")]
        [Required(ErrorMessage = "Datum je povinné pole")]
        public DateTime Datum { get; set; }

        public int MernaJednotkaId { get; set; }

        [ForeignKey(nameof(MernaJednotkaId))]
        public virtual MernaJednotka MernaJednotka { get; set; }

        public virtual ObservableCollection<Paleta> Palety { get; set; }


        //public int CelkoveMnozstvi
        //{
        //    get
        //    {
        //        if (Palety == null)
        //        {
        //            return 0;
        //        }
        //        else
        //        {
        //            //  return Palety.Sum(x => x.MnozPa);
        //            return Palety.Sum(Vypocet);
        //        }
        //    }
        //}

        //public int Vypocet (Paleta pal)
        //{
        //    return pal.MnozPa;
        //}

        public int CelkoveMnozstvi => (Palety == null) ? 0 : Palety.Sum(x => x.MnozPa);


    }
}
