﻿using DataEntity;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using PropertyChanged;

namespace Sklad.ViewModels
{
    [AddINotifyPropertyChangedInterface]

    public class PrehledMaterialuVM
    {

        private SkladContext context = new SkladContext();

        public void UlozitData()
        {
            context.SaveChanges();
        }

        private ObservableCollection<Material> _materialyCol; // vytvoření uzavřené vlastnosti
        public ObservableCollection<Material> MaterialyCol
        { //vytvoření kolekce materiálu
            get //vytvoření vlastního get set
            {
                if (_materialyCol == null)//pokud _materialyCol je prázdná (== porovnává hodnoty)
                    _materialyCol = new ObservableCollection<Material>(context.Materialy); // naplní _materialcol novou kolekcí z databáze(= nastavuje hodnotu)
                return _materialyCol;
            }
            //set
            //{
            //    _materialyCol = value;
            //}
        }
        public Material MaterialSelected { get; set; } //vrácení vybraného materiálu4

        public bool JeOznacenMaterial
        {
            get
            {
                return MaterialSelected != null;
            }
        }

        public string Jmeno
        {
            get
            {
                return "Karel";
            }
        }

        public enum Rezimy { Prohlizeni, Pridavani, Editace }

        private Rezimy _aktualniRezim = Rezimy.Prohlizeni;
        public Rezimy AktualniRezim
        {
            get
            {
                return _aktualniRezim;
            }
            set
            {
                _aktualniRezim = value;
                //následující řádka - příprava na to, aby nebylo možno používat menu při editaci
                //Globals._parentvm.LzePouzivatMenu = _aktualniRezim == Rezimy.Prohlizeni; 
            }


        }

        public string AktualniRezimString
        {
            get
            {
                switch (AktualniRezim)
                {
                    case Rezimy.Pridavani: return "Přidávání";
                    case Rezimy.Editace: return "Editace";
                }
                return "Prohlížení";
            }
        }


        public bool RezimPridavaniNeboEditace
        {
            get
            {
                return AktualniRezim != Rezimy.Prohlizeni;
            }
        }


        private ObservableCollection<MernaJednotka> _merneJednotkyCol;
        public ObservableCollection<MernaJednotka> MerneJednotkyCol
        {
            get
            {
                if (_merneJednotkyCol == null)
                    _merneJednotkyCol =
                        new ObservableCollection<MernaJednotka>(context.MerneJednotky);
                return _merneJednotkyCol;
            }
            set
            {
                _merneJednotkyCol = value;

            }
        }



    }
}
